Index: branches/ProblemRefactoring/HeuristicLab.Problems.Scheduling.Views/3.3/HeuristicLab.Problems.Scheduling.Views-3.3.csproj
===================================================================
--- branches/ProblemRefactoring/HeuristicLab.Problems.Scheduling.Views/3.3/HeuristicLab.Problems.Scheduling.Views-3.3.csproj	(revision 13443)
+++ branches/ProblemRefactoring/HeuristicLab.Problems.Scheduling.Views/3.3/HeuristicLab.Problems.Scheduling.Views-3.3.csproj	(revision 13449)
@@ -116,21 +116,7 @@
   </ItemGroup>
   <ItemGroup>
-    <Compile Include="JSMForcingStrategyView.cs">
-      <SubType>UserControl</SubType>
-    </Compile>
-    <Compile Include="JSMForcingStrategyView.Designer.cs">
-      <DependentUpon>JSMForcingStrategyView.cs</DependentUpon>
-    </Compile>
-    <Compile Include="JobShopSchedulingProblemView.cs">
-      <SubType>UserControl</SubType>
-    </Compile>
+    <Compile Include="JobShopSchedulingProblemView.cs" />
     <Compile Include="JobShopSchedulingProblemView.Designer.cs">
       <DependentUpon>JobShopSchedulingProblemView.cs</DependentUpon>
-    </Compile>
-    <Compile Include="JSMDecodingErrorPolicyView.cs">
-      <SubType>UserControl</SubType>
-    </Compile>
-    <Compile Include="JSMDecodingErrorPolicyView.Designer.cs">
-      <DependentUpon>JSMDecodingErrorPolicyView.cs</DependentUpon>
     </Compile>
     <Compile Include="Plugin.cs" />
Index: branches/ProblemRefactoring/HeuristicLab.Problems.Scheduling.Views/3.3/JSMDecodingErrorPolicyView.Designer.cs
===================================================================
--- branches/ProblemRefactoring/HeuristicLab.Problems.Scheduling.Views/3.3/JSMDecodingErrorPolicyView.Designer.cs	(revision 13443)
+++ 	(revision )
@@ -1,92 +1,0 @@
-#region License Information
-/* HeuristicLab
- * Copyright (C) 2002-2015 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
- *
- * This file is part of HeuristicLab.
- *
- * HeuristicLab is free software: you can redistribute it and/or modify
- * it under the terms of the GNU General Public License as published by
- * the Free Software Foundation, either version 3 of the License, or
- * (at your option) any later version.
- *
- * HeuristicLab is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
- */
-#endregion
-
-namespace HeuristicLab.Problems.Scheduling.Views {
-  partial class JSMDecodingErrorPolicyView {
-    /// <summary> 
-    /// Required designer variable.
-    /// </summary>
-    private System.ComponentModel.IContainer components = null;
-
-    /// <summary> 
-    /// Clean up any resources being used.
-    /// </summary>
-    /// <param name="disposing">true if managed resources should be disposed; otherwise, false.</param>
-    protected override void Dispose(bool disposing) {
-      if (disposing) {
-        if (components != null) components.Dispose();
-      }
-      base.Dispose(disposing);
-    }
-
-    #region Component Designer generated code
-
-    /// <summary> 
-    /// Required method for Designer support - do not modify 
-    /// the contents of this method with the code editor.
-    /// </summary>
-    private void InitializeComponent() {
-      this.valueLabel = new System.Windows.Forms.Label();
-      this.valueComboBox = new System.Windows.Forms.ComboBox();
-      this.SuspendLayout();
-      // 
-      // valueLabel
-      // 
-      this.valueLabel.AutoSize = true;
-      this.valueLabel.Location = new System.Drawing.Point(3, 3);
-      this.valueLabel.Name = "valueLabel";
-      this.valueLabel.Size = new System.Drawing.Size(34, 13);
-      this.valueLabel.TabIndex = 0;
-      this.valueLabel.Text = "&Type:";
-      // 
-      // valueComboBox
-      // 
-      this.valueComboBox.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)
-                  | System.Windows.Forms.AnchorStyles.Right)));
-      this.valueComboBox.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
-      this.valueComboBox.Enabled = false;
-      this.valueComboBox.FormattingEnabled = true;
-      this.valueComboBox.Location = new System.Drawing.Point(46, 0);
-      this.valueComboBox.Name = "valueComboBox";
-      this.valueComboBox.Size = new System.Drawing.Size(219, 21);
-      this.valueComboBox.TabIndex = 1;
-      this.valueComboBox.SelectedIndexChanged += new System.EventHandler(this.valueComboBox_SelectedIndexChanged);
-      // 
-      // PermutationTypeView
-      // 
-      this.AutoScaleDimensions = new System.Drawing.SizeF(6F, 13F);
-      this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Inherit;
-      this.Controls.Add(this.valueComboBox);
-      this.Controls.Add(this.valueLabel);
-      this.Name = "PermutationTypeView";
-      this.Size = new System.Drawing.Size(265, 29);
-      this.ResumeLayout(false);
-      this.PerformLayout();
-
-    }
-
-    #endregion
-
-    private System.Windows.Forms.Label valueLabel;
-    private System.Windows.Forms.ComboBox valueComboBox;
-
-  }
-}
Index: branches/ProblemRefactoring/HeuristicLab.Problems.Scheduling.Views/3.3/JSMDecodingErrorPolicyView.cs
===================================================================
--- branches/ProblemRefactoring/HeuristicLab.Problems.Scheduling.Views/3.3/JSMDecodingErrorPolicyView.cs	(revision 13443)
+++ 	(revision )
@@ -1,90 +1,0 @@
-#region License Information
-/* HeuristicLab
- * Copyright (C) 2002-2015 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
- *
- * This file is part of HeuristicLab.
- *
- * HeuristicLab is free software: you can redistribute it and/or modify
- * it under the terms of the GNU General Public License as published by
- * the Free Software Foundation, either version 3 of the License, or
- * (at your option) any later version.
- *
- * HeuristicLab is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
- */
-#endregion
-
-using System;
-using System.Windows.Forms;
-using HeuristicLab.Core.Views;
-using HeuristicLab.Encodings.ScheduleEncoding;
-using HeuristicLab.MainForm;
-
-namespace HeuristicLab.Problems.Scheduling.Views {
-  [View("JSMDecodingErrorPolicy View")]
-  [Content(typeof(JSMDecodingErrorPolicy), true)]
-  public partial class JSMDecodingErrorPolicyView : ItemView {
-
-    public new JSMDecodingErrorPolicy Content {
-      get { return (JSMDecodingErrorPolicy)base.Content; }
-      set { base.Content = value; }
-    }
-
-    public override bool ReadOnly {
-      get {
-        if ((Content != null) && Content.ReadOnly) return true;
-        return base.ReadOnly;
-      }
-      set { base.ReadOnly = value; }
-    }
-
-    public JSMDecodingErrorPolicyView() {
-      InitializeComponent();
-      valueComboBox.DataSource = Enum.GetValues(typeof(JSMDecodingErrorPolicyTypes));
-    }
-    public JSMDecodingErrorPolicyView(JSMDecodingErrorPolicy content)
-      : this() {
-      Content = content;
-    }
-
-    protected override void DeregisterContentEvents() {
-      Content.ValueChanged -= Content_ValueChanged;
-      base.DeregisterContentEvents();
-    }
-
-    protected override void RegisterContentEvents() {
-      base.RegisterContentEvents();
-      Content.ValueChanged += Content_ValueChanged;
-    }
-
-    protected override void OnContentChanged() {
-      base.OnContentChanged();
-      if (Content == null)
-        valueComboBox.Enabled = false;
-      else
-        valueComboBox.SelectedItem = Content.Value;
-    }
-
-    protected override void SetEnabledStateOfControls() {
-      base.SetEnabledStateOfControls();
-      if (Content == null) valueComboBox.Enabled = false;
-      else valueComboBox.Enabled = !ReadOnly;
-    }
-
-    private void Content_ValueChanged(object sender, EventArgs e) {
-      if (InvokeRequired)
-        Invoke(new EventHandler(Content_ValueChanged), sender, e);
-      else
-        valueComboBox.SelectedItem = Content.Value;
-    }
-
-    private void valueComboBox_SelectedIndexChanged(object sender, EventArgs e) {
-      if ((Content != null) && !Content.ReadOnly) Content.Value = (JSMDecodingErrorPolicyTypes)valueComboBox.SelectedItem;
-    }
-  }
-}
Index: branches/ProblemRefactoring/HeuristicLab.Problems.Scheduling.Views/3.3/JSMForcingStrategyView.Designer.cs
===================================================================
--- branches/ProblemRefactoring/HeuristicLab.Problems.Scheduling.Views/3.3/JSMForcingStrategyView.Designer.cs	(revision 13443)
+++ 	(revision )
@@ -1,92 +1,0 @@
-#region License Information
-/* HeuristicLab
- * Copyright (C) 2002-2015 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
- *
- * This file is part of HeuristicLab.
- *
- * HeuristicLab is free software: you can redistribute it and/or modify
- * it under the terms of the GNU General Public License as published by
- * the Free Software Foundation, either version 3 of the License, or
- * (at your option) any later version.
- *
- * HeuristicLab is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
- */
-#endregion
-
-namespace HeuristicLab.Problems.Scheduling.Views {
-  partial class JSMForcingStrategyView {
-    /// <summary> 
-    /// Required designer variable.
-    /// </summary>
-    private System.ComponentModel.IContainer components = null;
-
-    /// <summary> 
-    /// Clean up any resources being used.
-    /// </summary>
-    /// <param name="disposing">true if managed resources should be disposed; otherwise, false.</param>
-    protected override void Dispose(bool disposing) {
-      if (disposing) {
-        if (components != null) components.Dispose();
-      }
-      base.Dispose(disposing);
-    }
-
-    #region Component Designer generated code
-
-    /// <summary> 
-    /// Required method for Designer support - do not modify 
-    /// the contents of this method with the code editor.
-    /// </summary>
-    private void InitializeComponent() {
-      this.valueLabel = new System.Windows.Forms.Label();
-      this.valueComboBox = new System.Windows.Forms.ComboBox();
-      this.SuspendLayout();
-      // 
-      // valueLabel
-      // 
-      this.valueLabel.AutoSize = true;
-      this.valueLabel.Location = new System.Drawing.Point(3, 3);
-      this.valueLabel.Name = "valueLabel";
-      this.valueLabel.Size = new System.Drawing.Size(34, 13);
-      this.valueLabel.TabIndex = 0;
-      this.valueLabel.Text = "&Type:";
-      // 
-      // valueComboBox
-      // 
-      this.valueComboBox.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)
-                  | System.Windows.Forms.AnchorStyles.Right)));
-      this.valueComboBox.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
-      this.valueComboBox.Enabled = false;
-      this.valueComboBox.FormattingEnabled = true;
-      this.valueComboBox.Location = new System.Drawing.Point(46, 0);
-      this.valueComboBox.Name = "valueComboBox";
-      this.valueComboBox.Size = new System.Drawing.Size(219, 21);
-      this.valueComboBox.TabIndex = 1;
-      this.valueComboBox.SelectedIndexChanged += new System.EventHandler(this.valueComboBox_SelectedIndexChanged);
-      // 
-      // PermutationTypeView
-      // 
-      this.AutoScaleDimensions = new System.Drawing.SizeF(6F, 13F);
-      this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Inherit;
-      this.Controls.Add(this.valueComboBox);
-      this.Controls.Add(this.valueLabel);
-      this.Name = "PermutationTypeView";
-      this.Size = new System.Drawing.Size(265, 29);
-      this.ResumeLayout(false);
-      this.PerformLayout();
-
-    }
-
-    #endregion
-
-    private System.Windows.Forms.Label valueLabel;
-    private System.Windows.Forms.ComboBox valueComboBox;
-
-  }
-}
Index: branches/ProblemRefactoring/HeuristicLab.Problems.Scheduling.Views/3.3/JSMForcingStrategyView.cs
===================================================================
--- branches/ProblemRefactoring/HeuristicLab.Problems.Scheduling.Views/3.3/JSMForcingStrategyView.cs	(revision 13443)
+++ 	(revision )
@@ -1,90 +1,0 @@
-#region License Information
-/* HeuristicLab
- * Copyright (C) 2002-2015 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
- *
- * This file is part of HeuristicLab.
- *
- * HeuristicLab is free software: you can redistribute it and/or modify
- * it under the terms of the GNU General Public License as published by
- * the Free Software Foundation, either version 3 of the License, or
- * (at your option) any later version.
- *
- * HeuristicLab is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
- */
-#endregion
-
-using System;
-using System.Windows.Forms;
-using HeuristicLab.Core.Views;
-using HeuristicLab.Encodings.ScheduleEncoding;
-using HeuristicLab.MainForm;
-
-namespace HeuristicLab.Problems.Scheduling.Views {
-  [View("JSMForcingStrategy View")]
-  [Content(typeof(JSMForcingStrategy), true)]
-  public partial class JSMForcingStrategyView : ItemView {
-
-    public new JSMForcingStrategy Content {
-      get { return (JSMForcingStrategy)base.Content; }
-      set { base.Content = value; }
-    }
-
-    public override bool ReadOnly {
-      get {
-        if ((Content != null) && Content.ReadOnly) return true;
-        return base.ReadOnly;
-      }
-      set { base.ReadOnly = value; }
-    }
-
-    public JSMForcingStrategyView() {
-      InitializeComponent();
-      valueComboBox.DataSource = Enum.GetValues(typeof(JSMForcingStrategyTypes));
-    }
-    public JSMForcingStrategyView(JSMForcingStrategy content)
-      : this() {
-      Content = content;
-    }
-
-    protected override void DeregisterContentEvents() {
-      Content.ValueChanged -= Content_ValueChanged;
-      base.DeregisterContentEvents();
-    }
-
-    protected override void RegisterContentEvents() {
-      base.RegisterContentEvents();
-      Content.ValueChanged += Content_ValueChanged;
-    }
-
-    protected override void OnContentChanged() {
-      base.OnContentChanged();
-      if (Content == null)
-        valueComboBox.Enabled = false;
-      else
-        valueComboBox.SelectedItem = Content.Value;
-    }
-
-    protected override void SetEnabledStateOfControls() {
-      base.SetEnabledStateOfControls();
-      if (Content == null) valueComboBox.Enabled = false;
-      else valueComboBox.Enabled = !ReadOnly;
-    }
-
-    private void Content_ValueChanged(object sender, EventArgs e) {
-      if (InvokeRequired)
-        Invoke(new EventHandler(Content_ValueChanged), sender, e);
-      else
-        valueComboBox.SelectedItem = Content.Value;
-    }
-
-    private void valueComboBox_SelectedIndexChanged(object sender, EventArgs e) {
-      if ((Content != null) && !Content.ReadOnly) Content.Value = (JSMForcingStrategyTypes)valueComboBox.SelectedItem;
-    }
-  }
-}